  var mergewarning = "";
  var docstate = null;
  var State = {
    Database:{value:0, name:"Database"},
    FrequencySet: {value:1, name:"FrequencySet"},
    Frequency: {value:2, name:"Frequency"},
    Unknown: {value:-1, name:"Unknown"},
  };
  var curState = State.Database;
    
  
  // seterror - print error message. The message output varies
  //   depending if the database editor, the frequency set editor, or the 
  //   frequency editor is visible
  function seterror(str) {
    var err = DialogState.err();
    if (!str.length)
      str = "&nbsp;";
    
    if (err === null) {
      switch (curState) {
        case State.Database:
          err = document.getElementById("db_errorMsg");
          break;
        case State.FrequencySet:
          err = document.getElementById("fs_errorMsg");
          break;
        case State.Frequency:
          err = document.getElementById("fq_errorMsg");
          break;
      }
    }
    if (err !== null) {
      err.className = "tderror";
      err.innerHTML = str;
    }
  }

  // checkwarning - if there is a warning, display it
  function checkwarning() {
    if (mergewarning.length)
      seterror(mergewarning);
  }
  
  // reseterrors empties error message
  function reseterrors() {
    mergewarning = "";
    seterror("");
  }
  
  // cleanup - remove preceding space and trailing whitespace and commas
  function cleanup(str) {
    if (!str)
      return "";
    return str.replace(/^[\s]*/g, "").replace(/[\s,]*$/g, "");
  }

  // getwave get printable wave name
  function getwave(waveno) {
    retval = "None";
    switch (waveno) {
      case 1:
        retval = "Sine";
        break;
      case 2:
        retval = "Square";
        break;
      case 3:
        retval = "Sawtooth";
        break;
      case 4:
        retval = "Inv Sawtooth";
        break;
      case 5:
        retval = "Triangle";
        break;
      case 6:
        retval = "Damped Sine";
        break;
      case 7:
        retval = "Damped Square";
        break;
      case 8:
        retval = "H-Bomb Sine";
        break;
      case 9:
        retval = "H-Bomb Square";
        break;
    }
    return retval;
  }
  
  var waves = ["None", "Sine", "Square", "Sawtooth",
    "Inv Sawtooth", "Triangle", "Damped Sine", "Damped Square",
    "H-Bomb Sine", "H-Bomb Square"];
  
  // gate states Inherit means no Gate property specified in .csv
  var gates = ["Inherit", "Off", "On"];
  
  function appenderr(values, key, msg, nospace) {
    var val = values[key];
    var empty = (val === undefined || val === null || !val.length);
    if (empty)
      values[key] = "";
    else
      values[key] += nospace ? "," : ", ";
    values[key] += msg;
  }
  
  function badnum(str) {
    if (!str)
      return true;
    return isNaN(str);
  }
  
  var cleanup_list = ["freq", "last", "dwell", "wave", "amplitude", "offset",
    "gate", "phase", "factor", "constant",
  ];

	function MyRE() {}

  // MyRE.rmspace remove all white space
	MyRE.rmspace = function() {
    if (MyRE.rm_space === undefined)
      MyRE.rm_space = /\s/g;
    return MyRE.rm_space;
	}

  // MyRE.parseattr find attr code + value, or if not found, find bogus code / bogus value
	MyRE.parseattr = function() {
    if (MyRE.parse_attr === undefined)
      MyRE.parse_attr = /([WGPFCADO])(-?[\d\.]+)|([^\s])([^\sWGPFCADO]*)/gi;
    return MyRE.parse_attr;
	}

  // MyRE.attrstart find beginning of all attributes, i.e
  // 1-2 W8 O20
  //     ^ 
	MyRE.attrstart = function() {
    if (MyRE.attr_start === undefined)
      MyRE.attr_start = /[WGPFCADO]/i;
    return MyRE.attr_start;
	}

  // MyRE.freqBeforeDash find first freq of sweep
	MyRE.freqBeforeDash = function() {
    if (MyRE.freq_before_dash === undefined)
      MyRE.freq_before_dash = /^\s*(L?[^-]*)\s*-/i;
    return MyRE.freq_before_dash;
	}

  // MyRE.freqBeforeEqual find freq before dwell
 	MyRE.freqBeforeEqual = function() {
    if (MyRE.freq_before_equal === undefined)
      MyRE.freq_before_equal = /^\s*(L?[^=]*)\s*=/i;
    return MyRE.freq_before_equal;
	}

  // MyRE.freqBeforeAttr find freq before attribute
 	MyRE.freqBeforeAttr = function() {
    if (MyRE.freq_before_attr === undefined)
      MyRE.freq_before_attr = /^\s*(L?[^WGPFCADO\s]*)/i;
    return MyRE.freq_before_attr;
	}

  // MyRE.endFreqBeforeEqual find end of sweep before equal
 	MyRE.endFreqBeforeEqual = function() {
    if (MyRE.end_freq_before_equal === undefined)
      MyRE.end_freq_before_equal = /-\s*(L?[^=]*)\s*=/i;
    return MyRE.end_freq_before_equal;
	}


  // MyRE.endFreqBeforeAttr find end of sweep before attribute
 	MyRE.endFreqBeforeAttr = function() {
    if (MyRE.end_freq_before_attr === undefined)
      MyRE.end_freq_before_attr = /-\s*(L?[^WGPFCADO\s]*)/i;
    return MyRE.end_freq_before_attr;
	}

  // MyRE.dwellAfterEqual find end of sweep before attribute
 	MyRE.dwellAfterEqual = function() {
    if (MyRE.dwell_after_equal === undefined)
      MyRE.dwell_after_equal = /=\s*([^WGPFCADO\s]+)/i;
    return MyRE.dwell_after_equal;
	}

  // MyRE.freqOnly find end of sweep before attribute
 	MyRE.freqOnly = function() {
    if (MyRE.freq_only === undefined)
      MyRE.freq_only = /L?([\d\.]+)/i;
    return MyRE.freq_only;
	}

  // MyRE.csvAtEnd find end of sweep before attribute
 	MyRE.csvAtEnd = function() {
    if (MyRE.csv_at_end === undefined)
      MyRE.csv_at_end = /\.csv$/i;
    return MyRE.csv_at_end;
	}

  // MyRE.commaAtEnd find end of sweep before attribute
 	MyRE.commaAtEnd = function() {
    if (MyRE.comma_at_end === undefined)
      MyRE.comma_at_end = /,$/;
    return MyRE.comma_at_end;
	}

 
 function cleanvalues(values) {
    var rmspace = MyRE.rmspace();
    for (var i = 0; i < cleanup_list.length; i++) {
      var key = cleanup_list[i];
      var val = values[key];
      if (val !== null && val !== undefined){ 
        values[key] = val.replace(rmspace, "");
      }
    }
  }
  
  // parsefreqlist parse a single frequency list item from .csv
  function parsefreqlist(values, freq) {
    var dash = freq.search("-");
    var equal = freq.search("=");
    var attrstart = freq.search(MyRE.attrstart());
    var match = null, attrs = 0;
    var parseattr = MyRE.parseattr();

    if (attrstart < 0)
      attrstart = freq.length;
    values.err = "";
    if (dash >= 0 && dash <= attrstart)           // looking for freq before a dash
      match = MyRE.freqBeforeDash().exec(freq);
    else if (equal >= 0)                          // looking for freq before =
      match = MyRE.freqBeforeEqual().exec(freq);
    else                                          // looking for freq before attribute
      match = MyRE.freqBeforeAttr().exec(freq);
    values.freq = match ? match[1] : "";
    if (badnum(values.freq))
      appenderr(values, "err", "Invalid frequency “" + values.freq + "”");
    if (dash >= 0 && dash <= attrstart) {
      if (equal > dash)                           // looking for end freq before =
        match = MyRE.endFreqBeforeEqual().exec(freq);
      else                                        // looking for end freq before attribute
        match = MyRE.endFreqBeforeAttr().exec(freq);
      values.last = match ? match[1] : "";
      if (badnum(values.last))
        appenderr(values, "err", "Invalid end frequency “" + values.last + "”");
    } else
      values.last = null;
    if (equal >= 0) {
      match = MyRE.dwellAfterEqual().exec(freq);
      values.dwell = match ? match[1] : "";
      if (badnum(values.dwell))
        appenderr(values, "err", "Invalid dwell “" + values.dwell + "”");
    } else
      values.dwell = null;
    values.wave = null;
    values.gate = null;
    values.phase = null;
    values.factor = null;
    values.constant = null;
    values.amplitude = null;
    values.duty = null;
    values.offset = null;
    if (values.err)
      return;
    if (values.dwell)
      attrs++;
    parseattr.lastIndex = attrstart;
    while (match = parseattr.exec(freq)) {
      var prop = match[1];
      var val = match[2];
      switch (prop) {
        case "W":
        case "w":
          values.wave = val;
          break;
        case "G":
        case "g":
          values.gate = val;
          break;
        case "P":
        case "p":
          values.phase = val;
          break;
        case "F":
        case "f":
          values.factor = val;
          break;
        case "C":
        case "c":
          values.constant = val;
          break;
        case "A":
        case "a":
          values.amplitude = val;
          break;
        case "D":
        case "d":
          values.duty = val;
          break;
        case "O":
        case "o":
          values.offset = val;
          break;
        default:
          appenderr(values, "err", "Invalid attribute " + match[3] + " “" + match[4] + "”");
          break;
      }
      attrs++;
    }
    values.haveattrs = (attrs > 0);
    cleanvalues(values);
  }
  
  function printfreq(values) {
    str = values.freq ? values.freq : "";
    if (values.last)
      str += "-" + values.last;
    if (values.dwell)
      str += "=" + values.dwell;
    if (values.factor)
      str += "F" + values.factor;
    if (values.constant)
      str += "C" + values.constant;
    if (values.wave && values.wave != "0")
      str += " W" + values.wave;
    if (values.amplitude)
      str += " A" + values.amplitude;
    if (values.offset)
      str += " O" + values.offset;
    if (values.gate)
      str += " G" + values.gate;
    if (values.phase)
      str += " P" + values.phase;
    return str;
  }
  
  function get_values(data, prefix) {
    var i;
    values = {};
    for (i = 0; i < data.length; i++) {
      var key = data[i];
      var id = prefix + key;
      var el = document.getElementById(id);
      var val = el.value;
      if (el.type == "checkbox") {
        if (el.checked)
          values[key] = "1";
      } else if (val && val.length) {
        values[key] = val;
      }
    }
    return values;
  }
  
  function get_freq() {
    var data = cleanup_list;
    var values = get_values(data, "fq_");
    if (values.gate) {        // can be
      if (values.gate == "0")
        delete values.gate;
      else
        values.gate = "" + (parseInt(values.gate) - 1);
    }
    return values;
  }
  
  function get_freqset() {
    var data = ["name", "dwell", "comment", "sub", "freqs"
    ];
    return get_values(data, "fs_");
  }
  
  function get_save() {
    var data = ["name"];
    return get_values(data, "save_");
  }

  function normalize_freq(freqstr) {
    values = {};
    parsefreqlist(values, freqstr);
    return printfreq(values);
  }
  
  function getfreqlist(freqset, values) {
    var html = "";
    var list = freqset.freqlist;
    var i;
    if (list === null || list === undefined) {
      values.length = 0;
      return html;
    }
    for (i = 0; i < list.length; i++) {
      var str = list[i];
      html +="<li class='" + ((i%2 == 0) ? "fset2":"fset1") +" corner-all'><span class='setname'>";
      parsefreqlist(values, str);
      if (values.last) 
        html += values.freq + "-" + values.last;
      else
        html += values.freq;
      if (values.haveattrs)
        html += "<span class='comment'>";
      if (values.dwell)
        html += " Dwell:" + values.dwell;
      if (values.wave) 
        html += " Wave:" + waves[values.wave];
      if (values.gate)
        html += " Gate:" + gates[parseInt(values.gate) + 1];
      if (values.phase)
        html += " Phase:" + values.phase;
      if (values.factor)
        html += " Factor:" + values.factor;
      if (values.constant)
        html += " Constant:" + values.constant;
      if (values.amplitude)
        html += " Amplitude:" + values.amplitude;
      if (values.duty)
        html += " Duty:" + values.duty;
      if (values.offset)
        html += " Offset:" + values.offset;
      if (values.haveattrs)
        html += "<\/span>";
      html += "<span class='icons'><a class='a_ft'><span class='s_ft'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fu'><span class='s_fu'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fo'><span class='s_fo'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fb'><span class='s_fb'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fe'><span class='s_fe'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fc'><span class='s_fc'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_fd'><span class='s_fd'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><\/li>\r\n";
    }
    values.length = list.length;
    return html;
  }
  
  var NAME_MAX = 30;
  var COMMENT_MAX=90;
  var TOT_MAX = NAME_MAX + COMMENT_MAX;
  function checklengths(strs) {
    var namelen = strs.name.length; 
    var commentlen = strs.comment.length; 
    if (namelen + commentlen <= TOT_MAX)
      return;
    if (namelen > NAME_MAX)
      strs.name = strs.name.slice(0, NAME_MAX) + "…";
    namelen = strs.name.length; 
    if (namelen + commentlen > TOT_MAX)
      strs.comment = strs.comment.slice(0, TOT_MAX - namelen) + "…";
  }
  
  var mytooltip = null;
  
  function showtooltip(target, text) {
    var pos;
    var newpos = {left:0, top:0};
    var pageWidth = $(window).width();
    var max_x = pageWidth - 16;
    if (!mytooltip)
      mytooltip = $("#tooltip");
    mytooltip.offset(newpos);
    target = $(target);
    pos = target.offset();
    newpos.left = pos.left + target.width();
    newpos.top = pos.top + target.height();
    mytooltip.text(text);
    var toolwidth = mytooltip.width();
    if (newpos.left + toolwidth > max_x) 
      newpos.left = max_x - toolwidth; 
    mytooltip.offset(newpos);
    setclass(mytooltip[0], "tooltip_v");
  }
  
  function hidetooltip(target, text) {
    if (!mytooltip)
      mytooltip = $("#tooltip");
   setclass(mytooltip[0], "tooltip_h");
  }
  
  function show_fs_editor(freqset) {
    var dbedit = $("#db_editor");
    var fsedit = $("#fs_editor");
    var pos = dbedit.offset();
    var data = [
      ["#fs_freqlist", "html", null],
      [".fs_count", "html", null],
      ["#fs_name", "val", null],
      ["#fs_dwell", "val", null],
      ["#fs_comment", "val", null],
      ["#fs_sub", "val", null],
      ["#fs_freqs", "val", null],
    ];
    var linkdata = [
      ["fb", bottom_clicked],
      ["fc", duplicate_clicked],
      ["fd", delete_clicked],
      ["fe", edit_clicked],
      ["fo", down_clicked],
      ["ft", top_clicked],
      ["fu", up_clicked],
    ];
    var values = {};
    var setitem = freqset.setitem;
    fsedit.offset(pos);
    fsedit.width(dbedit.width());
    data[0][2] = getfreqlist(freqset, values);
    data[1][2] = values.length + " frequencies";
    data[2][2] = freqset.name;
    data[3][2] = freqset.dwell ? freqset.dwell : "180";
    data[4][2] = freqset.comment;
    data[5][2] = freqset.sub ? freqset.sub : "CUST";
    data[6][2] = freqset.freqs ? freqset.freqs : "";
    setjquery(data);
    setlinkdata(linkdata);
    show_fs_edit();
  }
  
  function show_fq_editor(freq) {
    var dbedit = $("#db_editor");
    var fqedit = $("#fq_editor");
    var pos = dbedit.offset();
    var data = [
      ["#fq_freq", "val", null],
      ["#fq_last", "val", null],
      ["#fq_wave", "val", null],
      ["#fq_dwell", "val", null],
      ["#fq_amplitude", "val", null],
      ["#fq_offset", "val", null],
      ["#fq_gate", "val", null],
      ["#fq_phase", "val", null],
      ["#fq_factor", "val", null],
      ["#fq_constant", "val", null],
    ];
    var values = {};
    fqedit.offset(pos);
    fqedit.width(dbedit.width());
    parsefreqlist(values, freq.freqstr);
    data[0][2] = values.freq;
    data[1][2] = values.last ? values.last : "";
    data[2][2] = values.wave ? values.wave : "0";
    data[3][2] = values.dwell ? values.dwell : "";
    data[4][2] = values.amplitude ? values.amplitude : "";
    data[5][2] = values.offset ? values.offset : "";
    data[6][2] = values.gate ? (1 + parseInt(values.gate)) + "" : "0";
    data[7][2] = values.phase ? values.phase : "";
    data[8][2] = values.factor ? values.gate : "";
    data[9][2] = values.constant ? values.phase : "";
    setjquery(data);
    show_fq_edit();
  }
  
  // data2blob converts the file contents into a blob (raw data) object
  function data2blob(data) {
    var blob=new Blob([data]);
    return blob;
  }
    
  function do_save(event) {
    var results = docstate.currentResults();
    var values = get_save();
    var name = checkstr(values.name, true);
    if (!name.length) {
      seterror("Missing file name");
      return;
    }
    if (!MyRE.csvAtEnd().exec(name))
      name += ".csv";
    saveAs(data2blob(results.sets.print(name)), name);
    load_db_status(results.sets);
    hide_dialog(event, true);
  }
  
  function ok_clicked(event) {
    reseterrors();
    if (!docstate.saveEdit()) {
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function import_clicked(event) {
    reseterrors();
    if (!event.target || !event.target.files.length) {
      seterror("No database selected");
      return null;
    }
    opencsv(event);
    hide_dialog(event);
    return event;
  }
  
  function do_import() {
    var event = {};
    event.target = $("#file_import")[0];
    import_clicked(event);
  }
  
  function cancel_clicked(event) {
    reseterrors();
    if (!docstate.cancelEdit()) {
      seterror("Not editing frequency set.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function bottom_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.bottomChildAt(index)) {
      seterror("Item at index " + index + " not found.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function down_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.downChildAt(index)) {
      seterror("Item at index " + index + " not found.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function top_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.topChildAt(index)) {
      seterror("Item at index " + index + " not found.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function up_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.upChildAt(index)) {
      seterror("Item at index " + index + " not found.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function load_fs_edit(freqset) {
    show_fs_editor(freqset);
    reseterrors();
    resizebottom();
  }

  function load_fq_edit(freq) {
    show_fq_editor(freq);
    reseterrors();
    resizebottom();
  }

  function edit_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    if (!docstate.editChildAt(index)) {
      seterror("Frequency at index " + index + " not found.");
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function duplicate_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.duplicateChildAt(index)) {
      seterror("can't find set " + index);
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function delete_clicked(event) {
    var target = event.target;
    var index = this.fe_i;
    reseterrors();
    if (!docstate.removeChildAt(index)) {
      seterror("can't find set " + index);
      return;
    }
    loadresults(docstate.currentResults());
  }
  
  function setclass(obj, name) {
    obj.className = name;
  }
  
  function setclassfor(classname, idname) {
    setclass(document.getElementById(idname), classname);
  }
  
  // icon_classes is data related to the various icon buttons
  //   array consists of triples -- span normal class, span hilit class,
  //   tooltip text.
  //
  var icon_classes = [
    "s_bo", "s_bo_h", "Move to bottom",
    "s_co", "s_co_h", "Duplicate",
    "s_de", "s_de_h", "Delete",
    "s_do", "s_do_h", "Move down",
    "s_ed", "s_ed_h", "Edit",
    "s_fb", "s_fb_h", "Move to bottom",
    "s_fc", "s_fc_h", "Duplicate",
    "s_fd", "s_fd_h", "Delete",
    "s_fe", "s_fe_h", "Edit",
    "s_fo", "s_fo_h", "Move down",
    "s_ft", "s_ft_h", "Move to top",
    "s_fu", "s_fu_h", "Move up",
    "s_ne", "s_ne_h", "New",
    "s_op", "s_op_h", "Open Database",
    "s_sa", "s_sa_h", "Save",
    "s_se", "s_se_h", "Search",
    "s_to", "s_to_h", "Move to top",
    "s_ud", "s_ud_h", "Undo",
    "s_up", "s_up_h", "Move up",
    "s_rd", "s_rd_h", "Redo",
    "s_cancel", "s_cancel_h", "Cancel Edits",
    "s_import", "s_import_h", "Import Database",
    "s_ok", "s_ok_h", "Save Edits",
    "s_closebutton", "s_closebutton_h", "Close",
  ];
  
  function toggletooltip(event) {
    var span = event.target;
    var className = span.className;
    var index = icon_classes.indexOf(className);
    if (index % 3 == 0) {   // currently not highlighted
      setclass(span, icon_classes[index + 1]);
      showtooltip(span, icon_classes[index + 2]);
    } else if (index % 3 == 1) {  // currently highlighted
      setclass(span, icon_classes[index - 1]);
      hidetooltip(span, icon_classes[index + 1]);
    }
  }
  
  // setlinkdata expects an array of 2 element array with values
  //   [ 2 letter link name, click function ]
  //   creates array of arrays for setjquery()
  //   for the input array, 
  //     ["ed", edit_clicked],
  //   the following 3 arrays are created
  //   [".a_ed", "click", edit_clicked],
  //   [".s_ed", "mouseenter", toggletooltip],
  //   [".s_ed", "mouseleave", toggletooltip],
  function setlinkdata(linkdata) {
    var data = [];
    var i, j;
    for (i = 0; i < linkdata.length; i++) {
      var link = linkdata[i];
      var name = link[0];
      var clickfunc = link[1];
      var span_name = ".s_" + name;
      var anchor_name = ".a_" + name;
      var anchors;
      data.push([anchor_name, "click", clickfunc]);
      data.push([span_name, "mouseenter", toggletooltip]);
      data.push([span_name, "mouseleave", toggletooltip]);
      anchors = $(anchor_name);
      // add index to all the anchors for the clickfunc to use
      for (j = 0; j < anchors.length; j++) {
        anchors[j].fe_i = j;
      }
    }
    setjquery(data);
  }
  
  function isempty(sets) {
    return sets == emptyDocument();
  }
  
  function show_db_edit() {
    if (curState != State.Database) {
      var dbedit = $("#db_editor");
      var fredit = $("#fs_editor");
      var fqedit = $("#fq_editor");
      curState = State.Database;
      setclass(dbedit[0], "db_editor");
      setclass(fredit[0], "fs_editor_h");
      setclass(fqedit[0], "fq_editor_h");
      focus("filein");
    }
  }
  
  function focus(key) {
    document.getElementById(key).focus();
  }
  
  function show_fs_edit() {
    if (curState != State.FrequencySet) {
      var dbedit = $("#db_editor");
      var fredit = $("#fs_editor");
      var fqedit = $("#fq_editor");
      curState = State.FrequencySet;
      setclass(dbedit[0], "db_editor_h");
      setclass(fredit[0], "fs_editor");
      setclass(fqedit[0], "fq_editor_h");
      focus("fs_name");
    }
  }

  function show_fq_edit() {
    if (curState != State.Frequency) {
      var dbedit = $("#db_editor");
      var fredit = $("#fs_editor");
      var fqedit = $("#fq_editor");
      curState = State.Frequency;
      setclass(dbedit[0], "db_editor_h");
      setclass(fredit[0], "fs_editor_h");
      setclass(fqedit[0], "fq_editor");
      focus("fq_freq");
    }
  }

  function show_save(parent) {
    if (curState == State.Database) {
      var results = docstate.currentResults();
      var file = results.sets.docname();
      if (file) {
        var data = [["#save_name", "val", file]];
        setjquery(data);
      }
      show_modal_dialog("save", "save_name", parent);
   }
  }

  function hide_search() {
    var search = $("#search_dialog");
    setclass(search[0], "search_dialog_h");
  }
  
  function close_clicked(event) {
    hide_dialog(event);
  }
  
  var dialog_state = null;
  
  function DialogState() {
    this.dialogs = [];
    this.modal = [];
  }
  
  DialogState.dialog_state = function() {
    if (dialog_state === null) 
      dialog_state = new DialogState();
    return dialog_state;
  }
  
  DialogState.err = function() {
    if (dialog_state === null)
      return null;
    val =dialog_state.cur_dialog();
    if (!val)
      return null;
    return val.err;
  }
  
  DialogState.prototype.cur_dialog = function() {
    if (!this.dialogs.length)
      return null;
    return this.dialogs[this.dialogs.length - 1];
  }
  
  DialogState.prototype.add_modal = function(parent, func) {
    var curDialog = this.cur_dialog();
    var span_selector = "#" + parent + " * span";
    var input_selector = "#" + parent + " * input";
    curDialog.spans = $(span_selector);
    curDialog.inputs = $(input_selector);
    curDialog.func = func;
    curDialog.spans.css("pointer-events", "none");
    curDialog.inputs.prop("disabled", true);
  }

  DialogState.prototype.remove_modal = function(success, curDialog) {
    curDialog.spans.css("pointer-events", "auto");
    curDialog.inputs.prop("disabled", false);
    if (success === undefined)
      success = false;
    if (success && curDialog.func !== undefined)
      curDialog.func();
    if (success) {
      if (this.dialogs.length) 
         hide_dialog(null, true);
    }
  }

  DialogState.prototype.show_dialog = function(root, focusname) {
    var name = root + "_dialog";
    var pageHeight = $(window).height();
    var pageWidth = $(window).width();
    var search = $("#" + name);
    var width = search.width();
    var height = search.height();
    var pos = {left: Math.floor((pageWidth - width)/2), 
      top: Math.floor((pageHeight - height)/2) };
    var dialog = {cur: search, name:name, 
      err:document.getElementById(root + "_errorMsg")};
    reseterrors();
    search.offset(pos);
    setclass(search[0], name);
    this.dialogs.push(dialog);
    if (focusname !== undefined && focusname !== null)
      focus(focusname);
  }
  
  function show_dialog(root, focusname) {
    DialogState.dialog_state().show_dialog(root, focusname);
  }
  

  function show_modal_dialog(name, focusname, parent, func) {
    var state = DialogState.dialog_state();
    state.show_dialog(name, focusname);
    state.add_modal(parent, func);
    reseterrors();
  }
  
  DialogState.prototype.hide_dialog = function(event, success) {
    var curDialog = this.dialogs.pop();
    setclass(curDialog.cur[0], curDialog.name + "_h");
    if (curDialog.spans)
      this.remove_modal(success, curDialog);
  }
  
  function hide_dialog(event, success) {
    DialogState.dialog_state().hide_dialog(event, success);
  }
  
  function show_search() {
    show_dialog("search", "sd_pattern");
  }
  
  // clearsearch clear search pattern text field, empty search results
  function clear_search() {
    var pattern = document.getElementById("sd_pattern");
    var searchresults = document.getElementById("searchresults");
    var data = [
      ["#sd_pattern", "val", ""],
      ["#searchresults", "html", ""],
      ["#s_se_msg", "html", "&nbsp;"],
    ];
    reseterrors();
    setclassfor("s_se_msg", "s_se_msg");
    setjquery(data);
  }
  
  function indexOf(list, item) {
    for (var i = 0; i < list.length; i++) {
      var child = list.item(i);
        if (child === item)
          return i;
    }
    return -1;
  }
  
  var se_indices;
  
  function se_result_clicked(event) {
    var child = event.target.parentNode.parentNode;
    var parent = child.parentNode;
    var children = parent.children;
    var index = indexOf(children, child);
    var builtin = new BuiltIn(se_indices[index]);
    if (!docstate.appendFrequencies(builtin)) 
      return;
    loadresults(docstate.currentResults());
  }

  // search_clicked find matches in frequencies and
  //   place new frequency set into searchresults
  function search_clicked(event) {
    var pattern = document.getElementById("sd_pattern").value;
    var searchresults = document.getElementById("searchresults");
    var regex;
    var i, j = 0;
    var resultval = "";
    var data;
    seterror("");
    pattern = cleanup(pattern);
    if (pattern.length == 0) {
      seterror("Search pattern is empty.");
      return;
    }
    regex = new RegExp(pattern, "i");
    se_indices = [];
    var builtin = new BuiltIn();
    for (i = 0; i < frequencies.length; i++ ) {
      builtin.setIndex(i);
      var name = builtin.name();
      var sub = builtin.sub();
      var comment = builtin.comment();
      if ((name.search(regex) >= 0) ||
        (comment.search(regex) >= 0)) {
        resultval += (
        "<li class='" + ((i%2 == 0) ? "fset2":"fset1") +" corner-all'><span class='setname'><a href='#'>" +
        name + "<\/a> <\/span><span class='comment'> " + sub + " " + 
        comment + "<\/span><\/li>\r\n") ;
        j++;
        se_indices.push(i);
      }
    }
    if (se_indices.length == 0) {
      data = [
        ["#s_se_msg", "html", "&nbsp;"],
        ["#searchresults", "html", ""],
      ];
      seterror("“" + pattern + "” not found.");
      setclassfor("s_se_msg_e", "s_se_msg");
    } else {
      data = [
        ["#searchresults", "html", resultval],
        ["li a", "click", se_result_clicked],
        ["#s_se_msg", "html", null],
      ];
      data[2][2] = se_indices.length + " found.";
      setclassfor("s_se_msg", "s_se_msg");
    }
    setjquery(data);
  }
  
  
  function search_keypress(event) {
    if (event.keyCode == 13) {
      search_clicked(event);
      return false;
    }
    if (event.keyCode == 27) {
      hide_dialog(event);
      return false;
    }
    return true;
  }
  
  function import_keypress(event) {
    if (event.keyCode == 27) {
      hide_dialog(event);
      return false;
    }
    return true;
  }
  
  function show_import() {
    if (curState == State.Database) {
      var file = $("#file_import");
      var target = file[0];
      if (target && target.files.length) {
        var data = [["#import_name", "val", target.files[0].name]];
        setjquery(data);
      }
      show_modal_dialog("import", "file_import", "db_editor");
    }
  }

  function load_db_status(sets) {
    var data = [
      [".db_count", "html", null],
      ];
    var docname = sets.docname();
    if (!docname)
      docname = "Untitled.csv";
    data[0][2] = docname + " – " + sets.length + " frequency sets";
    if (sets.isEdited())
      data[0][2] += " *";
    setjquery(data);
  }

  // loadsets loads freq sets into UI
  function loadsets(sets) {
    var i, html = "";
    var strs = {};
    var data = [
      ["#db_setlist", "html", null],
      ];
    var linkdata = [
      ["bo", bottom_clicked],
      ["co", duplicate_clicked],
      ["de", delete_clicked],
      ["do", down_clicked],
      ["ed", edit_clicked],
      ["to", top_clicked],
      ["up", up_clicked],
    ];
    if (!sets || isempty(sets)) {
      data[0][2] = "";
      setjquery(data);
      load_db_status(sets);
      return;
    }
    for (i = 0; i < sets.length;i++) {
      var setitem = sets[i];
      var comhtml;
      strs.name = setitem[0] ? setitem[0] : "";
      strs.comment = setitem[3] ? setitem[3] : "";
      checklengths(strs);
      comhtml = strs.comment.length ? "<span class='comment'>" + setitem[1] +
        ", " + strs.comment + "<\/span>" : "";
      html += "<li class='" + ((i%2 == 0) ? "fset2":"fset1") +" corner-all'><span class='setname'>" + strs.name + "<\/span> " + comhtml + "<span class='icons'><a class='a_to'><span class='s_to'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_up'><span class='s_up'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_do'><span class='s_do'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_bo'><span class='s_bo'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_ed'><span class='s_ed'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_co'><span class='s_co'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><a class='a_de'><span class='s_de'>&nbsp;&nbsp;&nbsp;&nbsp;<\/span><\/a><\/li>\r\n";
    }
    data[0][2] = html;
    setjquery(data);
    load_db_status(sets);
    setlinkdata(linkdata);
    show_db_edit();
    reseterrors();
  }
  
  // parse .csv custom frequency database
  function loaddatainternal(data, name, save) {
    var sets = CSVToArray(data, 8);
    sets.docname(name);
    loadsets(sets);
    if (save)
      docstate.addDoc(sets);
  }
  
  // loaddata parse data textarea into user interface
  function loaddata(data, name) {
    if (data.length == 0) {
      seterror("Data field is empty");
      return;
    }
    loaddatainternal(data, name, true);
    checkwarning();
  }

  // parse .csv custom frequency database
  function importdatainternal(data) {
    var sets = CSVToArray(data, 8);
    docstate.appendSets(sets);
  }
  
  // loaddata parse data textarea into user interface
  function importdata(data) {
    if (data.length == 0) {
      seterror("Data field is empty");
      return;
    }
    importdatainternal(data);
    loadresults(docstate.currentResults());
    checkwarning();
  }

  var reader = null; // unfortunate global
  
  // reader_onload is a callback from the FileReader.readAsText()
  function reader_onload() {
    var text = reader.result;
    if (reader._target.className == "filein")
      loaddata(text, reader._target.files[0].name);
    else
      importdata(text);
    reader = null;
  }
    
    // opencsv reads the contents of a local file, in this case
    //   the Spooky2 custom frequency database
  function opencsv(event) {
    var input = event.target;
    reseterrors();    
    reader = new FileReader();
    reader._target = input;
    reader.onload = reader_onload;
    reader.readAsText(input.files[0]);
  }
  
  function open_import_dialog(event) {
    show_import();
  }
  
  var initdoc = [
    [document, "ready", initui],
    [window, "resize", resizebottom],
  ];

  setjquery(initdoc);

  var initdata = [
    [".mybanner", "width", null],
    [".top", "width", null],
    ["#filein", "change", do_open],
    ["#file_import", "change", import_clicked],
    ["input[id*='fq_']", "keypress", fq_keypress],
    ["#fq_editor", "keypress", fq_keypress],
    ["input[id*='fq_']", "change", fq_changed],
    ["select[id*='fq_']", "change", fq_changed],
    ["select[id*='fs_']", "change", fs_changed],
    ["input[id*='fs_']", "change", fs_changed],
    ["input[id*='fs_']", "keypress", fs_keypress],
    ["#fs_editor", "keypress", fs_keypress],
    ["textarea[id*='fs_']", "change", fs_changed],
    ["textarea[id*='fs_']", "keypress", fs_keypress],
    ["#save_name", "keypress", save_keypress],
    ["div[id^='titlebar_'", "mousedown", search_mousedown],
    ["#sd_done", "click", hide_search],
    ["#sd_clear", "click", clear_search],
    ["#sd_search", "click", search_clicked],
    ["#sd_pattern", "keypress", search_keypress],
    ["#save_cancel", "click", hide_dialog],
    ["#save_save", "click", do_save],
    ["#import_cancel", "click", hide_dialog],
    ["#import_import", "click", do_import],
    ["#import_dialog", "keypress", import_keypress],
    ["#alert_cancel", "click", hide_dialog],
    ["#alert_dontsave", "click", alert_dontsave],
    ["#alert_save", "click", alert_save],
//  [null, "hide", null],
  ];
  
  var initlinkdata = [
    ["ne", new_clicked],
    ["op", open_clicked],
    ["sa", save_clicked],
    ["se", show_search],
    ["ud", undo_clicked],
    ["rd", redo_clicked],
    ["cancel", cancel_clicked],
    ["import", open_import_dialog],
    ["ok", ok_clicked],
    ["closebutton", close_clicked],
  ];
  
  function checkstr(str, docleanup) {
    if (str === undefined || str === null)
      return "";
    return docleanup ? cleanup(str) : str;
  }
  
  function fq_keypress(event) {
    if (event.keyCode == 13) {
      if (fq_changed(event))
        ok_clicked(event);
      event.stopPropagation();
      return false;
    }
    if (event.keyCode == 27) {
      cancel_clicked(event);
      event.stopPropagation();
      return false;
    }
    return true;
  }
  
  function fs_keypress(event) {
    if (event.keyCode == 13) {
      if (fs_changed(event))
        ok_clicked(event);
      event.stopPropagation();
      return false;
    }
    if (event.keyCode == 27) {
      cancel_clicked(event);
      event.stopPropagation();
      return false;
    }
    return true;
  }
  
  dragstate = {};
  
  function find_dialog(target) {
    var parent = target;
    while (parent = parent.parentNode) {
      if (parent.id.search(/_dialog$/) > 0)
        return parent;
    }
    return null;
  }
  
  function search_mousedown(event) {
    var dialog = find_dialog(event.target);
    dialog = $(dialog);
    var bpos = dialog.offset();
    dragstate.deltaX = event.clientX - bpos.left;
    dragstate.deltaY = event.clientY - bpos.top;
    dragstate.dialog = dialog;
    document.addEventListener("mousemove", search_mousemove);
    document.addEventListener("mouseup", search_mouseup);
  }
  
  function search_mouseup(event) {
    search_mousemove(event);
    document.removeEventListener("mousemove", search_mousemove);
    document.removeEventListener("mouseup", search_mouseup);
  }
  
  function search_mousemove(event) {
    var dialog = dragstate.dialog;
    var bpos = {};
    bpos.left = event.clientX - dragstate.deltaX;
    bpos.top = event.clientY - dragstate.deltaY;
    dialog.offset(bpos);
  }
  
  function save_keypress(event) {
    if (event.keyCode == 13) {
      do_save(event);
      return false;
    }
    if (event.keyCode == 27) {
      hide_dialog(event);
      return false;
    }
    return true;
  }
  
  function is_valid_freq_set(freqs, values) {
    if (!freqs)
      return false;
    if (values === undefined)
      values = {};
    var list = cleanup(freqs).split(",");
    for (var i = 0; i < list.length; i++) {
      var freq = list[i];
      if (!is_valid_freq_str(freq, i+1, values))
        return false;
    }
    return true;
  }
  
  function fs_changed(event) {
    var values = get_freqset();
    var textarea = event.target;
    var id = textarea.id;
    var changed = false;
    if (id == "fs_freqs") {
      var newvalues = {};
      reseterrors();
      if (!is_valid_freq_set(values.freqs, newvalues))
        return false;
      values.freqs = newvalues.normal.length ? newvalues.normal + "," : "";
    }
    var results = docstate.currentResults();
    if (results.state == State.FrequencySet)
      changed = results.freqset.freqsetChanged(values.freqs);
    docstate.setValues(values);
    if (changed)
      loadresults(docstate.currentResults());
    return true;
  }
  
  function fq_changed(event) {
    var values = get_freq();
    reseterrors();
    if (!valid_freq_values(values))
      return false;
    var str = printfreq(values);
    docstate.addIfChanged(str);
    return true;
  }
  
  function resizebottom() {
    var pageHeight = $(window).height();
    var pageWidth = $(window).width();
    var bottom;
    $("#db_editor").css({width: (pageWidth - 32) + "px"});
    $("#fq_editor").css({width: (pageWidth - 32) + "px"});
    $("#fs_editor").css({width: (pageWidth - 32) + "px"});
    switch (curState) {
      case State.Database:
        bottom = $("#bottom");
        break;
      case State.FrequencySet:
        bottom = $("#fs_bottom");
        var textareas = $("textarea[id*='fs_']");
        textareas.css({width: (pageWidth - (8 + 2*textareas.offset().left)) + "px"});
        break;
      case State.Frequency:
        return;
    }
    var pos = bottom.offset();
    bottom.css({maxHeight: (pageHeight - (pos.top + 4)) + "px",
      "overflow-y": "auto"});
  }
  
  function resize_se_bottom() {
    var dialog = $("#search_dialog");
    var pageHeight = dialog.height();
    var pageWidth = dialog.width();
    var bottom = $("#se_bottom");
    var pos = bottom.offset();
    bottom.css({maxHeight: (pageHeight - (pos.top + 4)) + "px",
      "overflow-y": "auto"});
  }
  
  function resizesearchbanner() {
    var banner = $("#titlebar_search");
    var parent = banner.parent();
    banner.width(parent.width());
  }

  function initui() {
    if (docstate === null) {
      docstate = new DocState();
    }
    setlinkdata(initlinkdata);
    setjquery(initdata);
    resizebottom();
    //resizesearchbanner();
    resize_se_bottom();
  }
  
  function save_clicked(e) {
    reseterrors();
    var results = docstate.currentResults();
    switch (results.state) {
      case State.Database:
        show_save("db_editor");
        break;
      case State.FrequencySet:
        seterror("Can't save from Frequency Set Editor");
        break;
      case State.Frequency:
        seterror("Can't save from Frequency Editor");
        break;
    }
  }
  
  function loadresults(results) {
    switch (results.state) {
      case State.Database:
        hide_search();
        loadsets(results.sets);
        break;
      case State.FrequencySet:
        load_fs_edit(results.freqset);
        break;
      case State.Frequency:
        hide_search();
        load_fq_edit(results.frequency);
        break;
    }
  }
  
  function undo_clicked(e) {
    reseterrors();
    if (!docstate.canUndo()) {
      seterror("Nothing to undo");
      return;
    }
    loadresults(docstate.nextUndo());
  }
  
  function redo_clicked(e) {
    reseterrors();
    if (!docstate.canRedo()) {
      seterror("Nothing to redo");
      return;
    }
    loadresults(docstate.nextRedo());
  }
  
  function new_clicked(e) {
    switch (curState) {
      case State.Database:
        if (!docstate.newFrequencySet())
          return;
        loadresults(docstate.currentResults());
        break;
      case State.FrequencySet:
        if (!docstate.newFrequency())
          return;
        loadresults(docstate.currentResults());
        break;
    }
  }
  
  function force_open(e) {
    do_open(e, true);
  }
  
  function do_open(e, dont_check_edit) {
    var event = {};
    event.target = $("#filein")[0];
    reseterrors();
    if (!event.target || !event.target.files.length) {
      seterror("No database selected");
      return;
    }
    if (dont_check_edit == undefined)
      dont_check_edit = false;
    if (!dont_check_edit) {
      var results = docstate.currentResults();
      if (results.sets.isEdited()) {
        var data = [
          ["#alert_msg", "html", null],
        ];
        data[0][2] = "<span class='alert_main'>Do you want to save changes to database?<br /></span><span class='alert_sub'>If you don’t save them, your changes will be lost.<\/span>";
        setjquery(data);
        show_modal_dialog("alert", "alert_dontsave", "db_editor", force_open);
        return;
      }
    }
    opencsv(event);
  }
  
  function open_clicked(event) {
    do_open(event);
  }
  
  function alert_dontsave(event) {
    hide_dialog(event);
    force_open(event);
  }

  function alert_save(event) {
    show_save("alert_dialog");
  }

  function setjquery(list) {
    var i, func, obj = null, arg;
    for (i = 0; i < list.length; i++) {
      var curItem = list[i];
      var newobj = $(curItem[0]);
      if (newobj != null)
        obj = newobj;
      func = obj[curItem[1]];
      arg = curItem[2];
      if (arg === null || arg === undefined)
        func.call(obj);
      else
        func.call(obj, arg);
    }
  }
  
  // ref: http://stackoverflow.com/a/1293163/2343
  // This will parse a delimited string into an array of
  // arrays. The default delimiter is the comma, but this
  // can be overriden in the third argument.
  function CSVToArray( strData, nvalues, strDelimiter ){
    // Check to see if the delimiter is defined. If not,
    // then default to comma.
    strDelimiter = (strDelimiter || ",");
    // Create a regular expression to parse the CSV values.
    var objPattern = new RegExp(
      (
        // Delimiters.
        "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
        // Quoted fields.
        "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
        // Standard fields.
        "([^\\" + strDelimiter + "\\r\\n]*))"
      ),
      "gi"
      );
    // Create an array to hold our data. Give the array
    // a default empty first row.
    var arrData = new Database();
    // Create an array to hold our individual pattern
    // matching groups.
    var arrMatches = null;
    // Keep looping over the regular expression matches
    // until we can no longer find a match.
    arrData.push([]);
    while (arrMatches = objPattern.exec( strData )){
        // Get the delimiter that was found.
        var strMatchedDelimiter = arrMatches[ 1 ];

        // Check to see if the given delimiter has a length
        // (is not the start of string) and if it matches
        // field delimiter. If id does not, then we know
        // that this delimiter is a row delimiter.
        if (strMatchedDelimiter.length &&
            strMatchedDelimiter !== strDelimiter
            ){
          // Since we have reached a new row of data,
          // add an empty row to our data array.
          arrData.push( [] );
        }
        var strMatchedValue;
        // Now that we have our delimiter out of the way,
        // let's check to see which kind of value we
        // captured (quoted or unquoted).
        if (arrMatches[ 2 ]){
          // We found a quoted value. When we capture
          // this value, unescape any double quotes.
          strMatchedValue = arrMatches[ 2 ].replace(
              new RegExp( "\"\"", "g" ), "\"" );
        } else {
            // We found a non-quoted value.
            strMatchedValue = arrMatches[ 3 ];
        }
        // Now that we have our value string, let's add
        // it to the data array.
        arrData[ arrData.length - 1 ].push( strMatchedValue );
    }
    // remove last element if empty.
    if (arrData.length > 0 && arrData[arrData.length - 1].length != nvalues)
      arrData.pop();
    // Return the parsed data.
    return( arrData );
  }
  
  // Beginning of Class definitions
  
  
  // BuiltIn class accesses the Spooky2 frequency database, to 
  //   put all the frequency array specific array indexes in one place
  function BuiltIn(index) {
    if (index === undefined || index === null)
      return;
    return this.setIndex(index);
  }
  
  // setIndex sets the current frequency sets at index
  BuiltIn.prototype.setIndex = function(index) {
    if (index < 0 || index >= frequencies.length)
      return null;
    this.index = index;
    this.items = frequencies[index];
  }
  
  // name returns the name of the frequency set
  BuiltIn.prototype.name = function() {
    return this.items[0];
  }
  
  // sub returns the sub database of the frequency set
  BuiltIn.prototype.sub = function() {
    return this.items[1];
  }
  
  // comment returns the comment of the frequency set
  BuiltIn.prototype.comment = function() {
    return this.items[2];
  }
  
  // freqs returns the frequencies of the frequency set
  BuiltIn.prototype.freqs = function() {
    return this.items[3];
  }
  
  // dwell returns the dwell of the frequency set
  BuiltIn.prototype.dwell = function() {
    return this.items[4];
  }
  
  // move_element move an array element from to to index
  function move_element(arr, from, to) {
    if (from < 0 || from >= arr.length)
      return false;
    var child = arr[from];
    arr.splice(from, 1);
    arr.splice(to, 0, child);
    arr.edited = true;
    return true;
 }
  
  // Database classes implements an array of frequency sets
  function Database() {
    Array.call(this);
    this.edited = false;
    this.name = "";
    return this;
  }
  
  // Database is a subclass of Array
  Database.prototype = Object.create(Array.prototype);
  Database.prototype.constructor = Database;
  
  // isEdited returns if database has been edited
  Database.prototype.isEdited = function() {
    return this.edited;
  }
  
  // isEdited returns if database has been edited
  Database.prototype.docname = function(newname) {
    if (newname !== undefined && newname !== null)
      this.name = newname;
    return this.name;
  }
  
  // copy returns a new shallow copy of database
  Database.prototype.copy = function() {
    var copy = new Database();
    var i;
    for (i = 0; i < this.length; i++) {
      copy.push(this[i]);
    }
    copy.edited = this.edited;
    copy.name = this.name;
    return copy
  }
  
  // removeChildAt removes frequency set at index
  Database.prototype.removeChildAt = function(index) {
    if (index < 0 || index >= this.length)
      return false;
    this.splice(index, 1);
    this.edited = true;
    return true;
  }
  
  // duplicateChildAt dups frequency set at index
  Database.prototype.duplicateChildAt = function(index) {
    if (index < 0 || index >= this.length)
      return false;
    this.splice(index+1, 0, this[index]);
    this.edited = true;
    return true;
  }
  
  // editChildAt creates a frequency set object for freq set at index
  Database.prototype.editChildAt = function(index) {
    if (index < 0 || index >= this.length)
      return null;
    var child = new FrequencySet(index, this, true);
    return child;
  }
  
  // topChildAt moves freq set at index to top (0)
  Database.prototype.topChildAt = function(index) {
    return move_element(this, index, 0);
  }
  
  // topChildAt moves freq set at index to bottom (this.length)
  Database.prototype.bottomChildAt = function(index) {
    return move_element(this, index, this.length);
  }
  
  // upChildAt moves freq set at index to index -1
  Database.prototype.upChildAt = function(index) {
    if (!index)
      return true;
    return move_element(this, index, index - 1);
  }
  
  // downChildAt moves freq set at index to index + 1
  Database.prototype.downChildAt = function(index) {
    if (index < this.length - 1) {
      return move_element(this, index, index + 1);
    }
    return true;
  }
  
  // haveParent database never has a parent
  Database.prototype.haveParent = function() {
    return false;
  }
  
  // save validates child, then place into database
  Database.prototype.save = function(child) {
    var new_fs;
    if (!child.isValid())
      return null;
    if (child.index < 0) {
      new_fs = [
        child.name, child.sub, "", child.comment,
        child.printfreqlist(), "", "", child.dwell,
      ];
      this.push(new_fs);
    } else {
      var old_fs = this[child.index];
      new_fs = [
        child.name, child.sub, old_fs[2], child.comment,
        child.printfreqlist(), old_fs[5], old_fs[6], child.dwell,
      ];
      this.splice(child.index, 1, new_fs);
    }
    this.edited = true;
    return this;
  }
  
  // db_commas these items ought to be quoted in output -- name 0, comment 3,
  //   freq set 4
  var db_commas = [true, false, false, true, true,false, false, false];
  
  // printset creates csv for a single frequency set
  Database.prototype.printset = function(freqset) {
    var str = "";
    for (var i = 0; i < freqset.length; i++) {
      var cur = freqset[i];
      var quote = db_commas[i];
      if (i == 4 && !cur)
        cur = "0,";
      if (!cur)
        cur = "";
      if (!quote)
        quote = (cur.search(",") >= 0);
      cur = cur.replace(/"/g, "'");
      cur = cur.replace(/[\r\n]/g, " ");
      if (i)
        str += ",";
      if (quote)
        str += '"' + cur + '"';
      else
        str += cur;
    }
    str += "\r\n";
    return str;
  }
  
  // print creates csv for entire database
  Database.prototype.print = function(name) {
    var str = "";
    for (var i = 0; i < this.length; i++) {
      str += this.printset(this[i]);
    }
    this.edited = false;
    this.name = name;
    return str;
  }
  
  // appendSets append a list of frequency sets to database (import)
  Database.prototype.appendSets = function(sets) {
    for (var i = 0; i < sets.length; i++) {
      this.push(sets[i]);
    }
    if (sets.length)
      this.edited = true;
  }
  
  
  // Frequency class implements a single frequency (element of FrequencySet)
  function Frequency(index, frequencyset, freqstr, normalize) {
    this.parent = frequencyset;
    this.freqstr = normalize ? normalize_freq(freqstr) : freqstr;
    this.index = index;
  }
  
  // haveParent Frequency always have parent
  Frequency.prototype.haveParent = function() {
    return true;
  }
  
  // copy return a copy of Frequency
  Frequency.prototype.copy = function() {
    var copy = new Frequency(this.index, this.parent, this.freqstr, false);
    return copy;
  }
  
  // checkfreq do some error checking
  function checkfreq(str, missingOk, msg) {
    if (str === null || str === undefined)
      return true;
    if (!str || !str.length) {
      if (missingOk)
        return true;
      seterror("Missing or invalid " + msg);
      return false;
    }
    var match = MyRE.freqOnly().exec(str);
    if (!match) {
      seterror("Invalid " + msg + " “" + str + "”");
      return false;
    }
    if (isNaN(match[1])) {
      seterror("Invalid " + msg + " “" + str + "”");
      return false;
    }
    return true;
  }
  
  // checknum validate numeric values range
  function checknum(str, msg, min, max) {
    if (str === null || str === undefined)
      return true;
    if (!str || !str.length || isNaN(str)) {
      seterror("Invalid " + msg + " “" + str + "”");
      return false;
    }
    if (min === undefined && max === undefined)
      return true;
    var val = parseFloat(str);
    if (min !== undefined) {
      if (val < min) {
        seterror(msg + " must be greater than or equal to " + min);
        return false;
      }
    }
    if (max !== undefined) {
      if (val > max) {
        seterror(msg + " must be less than or equal to " + max);
        return false;
      }
    }
    return true;
  }
  
  // fq_attr_list numeric values to be validated
  var fq_attr_list = [
    ["dwell", "Dwell"],
    ["amplitude", "Amplitude", 0, 20],
    ["offset", "Offset", -100, 100],
    ["gate", "Gate", 0, 1],
    ["phase", "Phase"],
    ["factor", "Factor"],
    ["constant", "Constant"],
    ["wave", "Wave", 0, 9],
  ];
  
 // valid_freq_values check all values before saving
 function valid_freq_values(values, index) {
    if (values.err) {
      if (index !== undefined)
        values.err += " in frequency " + index;
      seterror(values.err);
      return false;
    }
    if (!checkfreq(values.freq, false, "Frequency"))
      return false;
    if (!checkfreq(values.last, true, "End Frequency"))
      return false;
    for (var i = 0; i < fq_attr_list.length; i++) {
      var pair = fq_attr_list[i];
      if (!checknum(values[pair[0]], pair[1], pair[2], pair[3]))
        return false;
    }
    return true;
  }
 
 // is_valid_freq_str check all values before saving
 function is_valid_freq_str(str, index, values) {
    var normalize = false;
    if (values === undefined)
      values = {};
    else 
      normalize = true;
    parsefreqlist(values, str);
    if (normalize)
      appenderr(values, "normal", printfreq(values), true);
    return valid_freq_values(values, index);
  }
  
  
  // isValid check all values before saving
  Frequency.prototype.isValid = function() {
    return is_valid_freq_str(this.freqstr);
  }
  
 // FrequencySet class implements a single frequency set
  function FrequencySet(index, parent, mkfreq) {
    if (index < 0) {
      this.setitem = ["", "CUST", "", "", "", "", "", "180", ];
      this.freqlist = [];
    } else  {
      this.setitem = parent[index];
    }
    this.parent = parent;
    this.name = this.setitem[0];
    this.sub = this.setitem[1];
    this.comment = this.setitem[3];
    this.freqs = this.setitem[4];
    this.dwell = this.setitem[7];
    this.index = index;
    if (mkfreq)
      this.freqlist = cleanup(this.freqs).split(",");
  }
  
  
 // copy returns a copy of frequency set
  FrequencySet.prototype.copy = function() {
    var copy = new FrequencySet(this.index, this.parent, false);
    copy.setitem = this.setitem;
    copy.parent = this.parent;
    copy.name = this.name;
    copy.sub = this.sub;
    copy.comment = this.comment;
    copy.freqs = this.freqs;
    copy.dwell = this.dwell;
    copy.index = this.index;
    copy.freqlist = this.freqlist.slice();
    return copy;
  }
  
 // removeChildAt deletes frequency at index
  FrequencySet.prototype.removeChildAt = function(index) {
    if (index < 0 || index >= this.freqlist.length)
      return false;
    this.freqlist.splice(index, 1);
    this.freqs = this.printfreqlist();
    return true;
  }
  
 // duplicateChildAt dups frequency at index
  FrequencySet.prototype.duplicateChildAt = function(index) {
    if (index < 0 || index >= this.freqlist.length)
      return false;
    this.freqlist.splice(index+1, 0, this.freqlist[index]);
    this.freqs = this.printfreqlist();
    return true;
  }
  
 // editChildAt start editing a frequency at index
  FrequencySet.prototype.editChildAt = function(index) {
    if (index < 0 || index >= this.freqlist.length)
      return null;
    var child = new Frequency(index, this, this.freqlist[index], true)
    return child;
  }
  
 // topChildAt move frequency at index to top 0
  FrequencySet.prototype.topChildAt = function(index) {
    var ret = move_element(this.freqlist, index, 0);
    this.freqs = this.printfreqlist();
    return ret;
  }
  
 // bottomChildAt move frequency at index to bottom freqlist.length
  FrequencySet.prototype.bottomChildAt = function(index) {
    var ret = move_element(this.freqlist, index, this.freqlist.length);
    this.freqs = this.printfreqlist();
    return ret;
  }
  
 // upChildAt move frequency at index up one (index -1 )
  FrequencySet.prototype.upChildAt = function(index) {
    if (!index)
      return true;
    var ret = move_element(this.freqlist, index, index - 1);
    this.freqs = this.printfreqlist();
    return ret;
  }
  
 // downChildAt move frequency at index down one (index +1 )
  FrequencySet.prototype.downChildAt = function(index) {
    if (index < this.freqlist.length - 1) {
      var ret = move_element(this.freqlist, index, index + 1);
      this.freqs = this.printfreqlist();
      return ret;
    }
    return true;
  }
  
 // haveParent FrequencySet always has parent
  FrequencySet.prototype.haveParent = function() {
    return true;
  }
  
 // save check Frequency is OK, then save at child.index
  FrequencySet.prototype.save = function(child) {
    if (!child.isValid())
      return null;
    if (child.index < 0)
      this.freqlist.push(child.freqstr);
    else
      this.freqlist.splice(child.index, 1, child.freqstr);
    this.freqs = this.printfreqlist();
    return this;
  }
  
 // isValid validates values for edited frequency set
  FrequencySet.prototype.isValid = function() {
    if (!this.freqlist || !this.freqlist.length) {
      seterror("No frequencies in frequency set");
      return false;
    }
    if (!cleanup(this.name).length) {
      seterror("Missing name");
      return false;
    }
    if (!checknum(this.dwell, "dwell"))
      return false;
    return true;
  }
  
 // printfreqlist creates freq list csv output for a freq list value [4]
  FrequencySet.prototype.printfreqlist = function() {
    return this.freqlist.join(",") + ",";
  }
  
  // valuesChanged true if passed in values are different from freq set values
  FrequencySet.prototype.valuesChanged = function(values) {
    var keys = ["name", "dwell", "comment", "sub", "freqs"];
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var s1 = checkstr(this[key], false);
      var s2 = checkstr(values[key], false);
      if (s1 != s2)
        return true;
    }
    return false;
  }
  
  // valuesChanged true if passed in values are different from freq set values
  FrequencySet.prototype.freqsetChanged = function(str) {
    var s1 = checkstr(this.freqset, false);
    var s2 = checkstr(str, false);
    if (s1 != s2)
      return true;
    return false;
  }
  
  // addDwell add dwell to elements of a frequency set who have no dwell
  function addDwell(str, dwell) {
    var list = cleanup(str).split(",");
    var i;
    var result = "";
    var dwellpat = new RegExp("([\\d\\.-]+)");    // match only the freq
    for (i = 0; i < list.length; i++) {
      var pos = list[i].indexOf("=");
      if (pos < 0) {
        result += list[i].replace(dwellpat, "$1=" + dwell) + ",";
      } else {
        result += list[i] + ",";
      }
    }
    return result;
  }
        
  // appendFrequencies append freqs from Spooky2 db to frequency set
  FrequencySet.prototype.appendFrequencies = function(builtin) {
    var newdwell = builtin.dwell();
    var comment = builtin.name() + " - " + builtin.sub();
    var len = this.freqs.length;
    var freqs = builtin.freqs();
    if (len == 0) {
      this.freqs = freqs;
      if (this.dwell != newdwell)
        this.dwell = newdwell;
    } else {
      var matches = MyRE.commaAtEnd().exec(this.freqs);
      if (!matches)
        this.freqs += ",";
      if (this.dwell != newdwell)
        this.freqs += addDwell(freqs, newdwell);
      else
        this.freqs += freqs;
    }
    if (this.comment && this.comment.length)
      this.comment += ", " + comment;
    else
      this.comment = comment;
    this.freqlist = cleanup(this.freqs).split(",");
  }
  
  var emptyDoc = null;
  
  // emptyDocument return global empty document
  function emptyDocument() {
    if (emptyDoc === null || emptyDoc === undefined)
      emptyDoc = new Database();
    return emptyDoc;
  }
  
  // DocState class manages undo/redo state of editor
  function DocState() {
    this.docs = [];
    this.docs.push(emptyDocument());
    this.curStateIndex = 0;
  }
  
  // addDoc remove undo docs if any, then push doc
  DocState.prototype.addDoc = function(doc) {
    if (this.curStateIndex < this.docs.length - 1) {
      var removefrom = this.curStateIndex + 1;
      this.docs.splice(removefrom, this.docs.length - removefrom);
    }
    this.docs.push(doc);
    this.curStateIndex++;
    return this;
  }
    
  // canUndo returns true if there is anything to undo
  DocState.prototype.canUndo = function() {
    return (this.curStateIndex > 0);
  }
  
  // stateForDoc return state of doc based on object class
  DocState.prototype.stateForDoc = function(doc) {
    if (doc instanceof Database)
      return State.Database;
    if (doc instanceof FrequencySet) 
      return State.FrequencySet;
    if (doc instanceof Frequency) 
      return State.Frequency;
    return State.Unknown;
  }
  
  //   results.state is State.Database if the current doc is a set, 
  //   false if is FrequencySet
  //   results.sets = Array of sets, results.freqset = single freq set
  DocState.prototype.resultsForDoc = function(doc) {
    var results = {};
    results.state = this.stateForDoc(doc);
    switch (results.state) {
      case State.Database:
        results.sets = doc;
      case State.FrequencySet:
        results.freqset = doc;
        break;
      case State.Frequency:
        results.frequency = doc;
        break;
    }
    return results;
  }
  
  // currentResults return current doc with state
  DocState.prototype.currentResults = function() {
    var curdoc = this.currentDoc();
    return this.resultsForDoc(curdoc);
  }

    
  // nextUndo return 2 results. if no current docs, return null
  DocState.prototype.nextUndo = function() {
    if (!this.curStateIndex)
      return null;
    this.curStateIndex--;
    return this.resultsForDoc(this.docs[this.curStateIndex]);
  }
    
  // canRedo returns true if there is anything to redo
  DocState.prototype.canRedo = function() {
    return (this.curStateIndex < this.docs.length - 1);
  }
    
  // nextRedo return the next redo doc. If none remain, returns null
  DocState.prototype.nextRedo = function() {
    if (this.curStateIndex >= this.docs.length - 1)
      return null;
    this.curStateIndex++;
    return this.resultsForDoc(this.docs[this.curStateIndex]);
  }
  
  // doAt for the current document, call func for the set at index
  DocState.prototype.doAt = function(index, func) {
    var copy;
    if (index < 0)
      return false;
    var curdoc = this.currentDoc();
    copy = curdoc.copy();
    var func = copy[func];
    if (!func.call(copy, index))
      return false;
    this.addDoc(copy);
    return true;
  }
  
  // removeChildAt for the current document, removes the set at index
  DocState.prototype.removeChildAt = function(index) {
    return this.doAt(index, "removeChildAt");
  }
  
  // duplicateChildAt for the current document, removes the set at index
  DocState.prototype.duplicateChildAt = function(index) {
    return this.doAt(index, "duplicateChildAt");
  }
  
  // topChildAt for the current document, move item at index to top
  DocState.prototype.topChildAt = function(index) {
    return this.doAt(index, "topChildAt");
  }
  
  // bottomChildAt for the current document, move item at index to bottom
  DocState.prototype.bottomChildAt = function(index) {
    return this.doAt(index, "bottomChildAt");
  }
  
  // upChildAt for the current document, move item at index to index - 1
  DocState.prototype.upChildAt = function(index) {
    return this.doAt(index, "upChildAt");
  }
  
  // downChildAt for the current document, move item at index to index + 1
  DocState.prototype.downChildAt = function(index) {
    return this.doAt(index, "downChildAt");
  }
  
  // currentDoc return the current document
  DocState.prototype.currentDoc = function() {
    return this.docs[this.curStateIndex];
  }

  // editChildAt returns a new child at index, pushes new 
  //   child onto undo/redo stack
  DocState.prototype.editChildAt = function(index) {
    var curdoc = this.currentDoc();
    if (!curdoc)
      return false;
    if (index < 0)
      return false;
    var child = curdoc.editChildAt(index);
    if (child)
      this.addDoc(child);
    return true;
  }
  
  // cancelEdit starts editing the frequency set at index
  DocState.prototype.cancelEdit = function() {
    var edit = this.currentDoc();
    if (!edit)
      return false;
    if (!edit.haveParent())
      return false;
    this.addDoc(edit.parent.copy());
    return true;
  }
  
  // saveEdit starts editing the frequency set at index
  DocState.prototype.saveEdit = function() {
    var edit = this.currentDoc();
    if (!edit)
      return false;
    if (!edit.haveParent())
      return false;
    var saved = edit.parent.copy().save(edit);
    if (!saved)
      return false;
    this.addDoc(saved);
    return true;
  }
  
  // addIfChanged for current doc, add if values have changed
  DocState.prototype.addIfChanged = function(str) {
    var doc = this.currentDoc();
    if (!doc)
      return false;
    var state = this.stateForDoc(doc);
    if (state != State.Frequency)
      return false;
    if (str != doc.freqstr) {
      var newdoc = doc.copy();
      newdoc.freqstr = str;
      this.addDoc(newdoc);
      return true;
    }
    return false;
  }

  // appendSets import sets
  DocState.prototype.appendSets = function(sets) {
    var newdoc, doc = this.currentDoc();
    if (doc) {
      var state = this.stateForDoc(doc);
      if (state != State.Database)
        return false;
      newdoc = doc.copy();
    } else 
      newdoc = new Database();
    newdoc.appendSets(sets);
    this.addDoc(newdoc);
    return true;
  }
  
  // setValues for current doc, if values are different from current
  //   frequency set, reflect new values 
  DocState.prototype.setValues = function(values) {
    var doc = this.currentDoc();
    if (!doc)
      return false;
    var state = this.stateForDoc(doc);
    if (state != State.FrequencySet)
      return false;
    if (doc.valuesChanged(values)) {
      var newdoc = doc.copy();
      newdoc.name = checkstr(values["name"], true);
      newdoc.dwell = checkstr(values["dwell"], true);
      newdoc.comment = checkstr(values["comment"], true);
      newdoc.sub = checkstr(values["sub"], true);
      newdoc.freqs = checkstr(values["freqs"], true);
      newdoc.freqlist = newdoc.freqs ? cleanup(newdoc.freqs).split(","):[];
      console.log(newdoc.freqlist);
      this.addDoc(newdoc);
      return true;
    }
    return false;
  }

  // newFrequencySet if current doc is Database, create a new empty freq set 
  DocState.prototype.newFrequencySet = function() {
    var doc = this.currentDoc();
    var state = this.stateForDoc(doc);
    if (state != State.Database)
      return false;
    var newdoc = new FrequencySet(-1, doc, false);
    this.addDoc(newdoc);
    return true;
  }
    
  // newFrequency if current doc is FrequencySet, create a new empty freq 
  DocState.prototype.newFrequency = function() {
    var doc = this.currentDoc();
    var state = this.stateForDoc(doc);
    if (state != State.FrequencySet)
      return false;
    var newdoc = new Frequency(-1, doc, "", false);
    this.addDoc(newdoc);
    return true;
  }
    
  // appendFrequencies append freqs from builtin Spooky2 database 
  DocState.prototype.appendFrequencies = function(builtin) {
    var doc = this.currentDoc();
    var state = this.stateForDoc(doc);
    if (state != State.FrequencySet)
      return false;
    var newdoc = doc.copy();
    newdoc.appendFrequencies(builtin);
    this.addDoc(newdoc);
    return true;
  }
    

